#
# spec file for package perl-MooseX-Types
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-MooseX-Types
Version:        0.50
Release:        1.28
%define cpan_name MooseX-Types
Summary:        Organise your Moose types in libraries
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/MooseX-Types/
Source0:        http://www.cpan.org/authors/id/E/ET/ETHER/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Carp::Clan) >= 6.00
BuildRequires:  perl(Module::Build::Tiny) >= 0.034
BuildRequires:  perl(Module::Metadata)
BuildRequires:  perl(Module::Runtime)
BuildRequires:  perl(Moose) >= 1.06
BuildRequires:  perl(Moose::Exporter)
BuildRequires:  perl(Moose::Meta::TypeConstraint::Union)
BuildRequires:  perl(Moose::Role)
BuildRequires:  perl(Moose::Util::TypeConstraints)
BuildRequires:  perl(Scalar::Util) >= 1.19
BuildRequires:  perl(Sub::Exporter)
BuildRequires:  perl(Sub::Exporter::ForMethods) >= 0.100052
BuildRequires:  perl(Sub::Install)
BuildRequires:  perl(Sub::Name)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Requires)
BuildRequires:  perl(namespace::autoclean) >= 0.16
Requires:       perl(Carp::Clan) >= 6.00
Requires:       perl(Module::Runtime)
Requires:       perl(Moose) >= 1.06
Requires:       perl(Moose::Exporter)
Requires:       perl(Moose::Meta::TypeConstraint::Union)
Requires:       perl(Moose::Util::TypeConstraints)
Requires:       perl(Scalar::Util) >= 1.19
Requires:       perl(Sub::Exporter)
Requires:       perl(Sub::Exporter::ForMethods) >= 0.100052
Requires:       perl(Sub::Install)
Requires:       perl(Sub::Name)
Requires:       perl(namespace::autoclean) >= 0.16
%{perl_requires}

%description
The type system provided by Moose effectively makes all of its builtin type
global, as are any types you declare with Moose. This means that every
module that declares a type named 'PositiveInt' is sharing the same type
object. This can be a problem when different parts of the code base want to
use the same name for different things.

This package lets you declare types using short names, but behind the
scenes it namespaces all your type declarations, effectively prevent name
clashes between packages.

This is done by creating a type library module like 'MyApp::Types' and then
importing types from that module into other modules.

As a side effect, the declaration mechanism allows you to write type names
as barewords (really function calls), which catches typos in names at
compile time rather than run time.

This module also provides some helper functions for using Moose types
outside of attribute declarations.

If you mix string-based names with types created by this module, it will
warn, with a few exceptions. If you are declaring a 'class_type()' or
'role_type()' within your type library, or if you use a fully qualified
name like '"MyApp::Foo"'.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Build.PL --installdirs=vendor
./Build build --flags=%{?_smp_mflags}

%check
./Build test

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes CONTRIBUTING LICENCE README

%changelog
* Wed Feb  8 2017 coolo@suse.com
- updated to 0.50
  see /usr/share/doc/packages/perl-MooseX-Types/Changes
  0.50      2017-02-07 18:59:30Z
  - reverted the is_Fo and to_Foo refactoring again temporarily to
    resolve issues with Sub::Defer
* Fri Dec 23 2016 coolo@suse.com
- updated to 0.49
  see /usr/share/doc/packages/perl-MooseX-Types/Changes
  0.49      2016-12-23 00:12:12Z
  - made the exported is_Foo and to_Foo subs much faster, especially for
    type constraints which can be inlined. (Dave Rolsky)
* Thu Dec  8 2016 coolo@suse.com
- updated to 0.48
  see /usr/share/doc/packages/perl-MooseX-Types/Changes
  0.48      2016-12-07 01:15:14Z
  - reverted is_Foo and to_Foo refactoring [from 0.47] for now, so they
    can be reworked
  0.47      2016-12-07 00:40:34Z
  - allow type libraries built with MooseX::Types::Combine to be
    combined with MooseX::Types::Combine. (GH #1, Mark Fowler).
  - made the exported is_Foo and to_Foo subs much faster, especially for
    type constraints which can be inlined [reverted in 0.48]
* Wed Aug 19 2015 coolo@suse.com
- updated to 0.46
  see /usr/share/doc/packages/perl-MooseX-Types/Changes
  0.46      2015-08-16 00:43:46Z
  - make use of Sub::Exporter::ForMethods's new rebless option
* Mon Sep 15 2014 coolo@suse.com
- updated to 0.45
  - increase the required versions of some prerequisites
* Mon Mar 10 2014 coolo@suse.com
- updated to 0.44
  - full respect for namespaces: declared types are now properly
    installed into the proper package, so they survive
    namespace::autoclean; however, types imported from the declaration
    class are still properly cleaned by namespace::autoclean (as
    implemented in trial versions 0.40-0.43)
  - line numbers in shipped code are now almost the same (within 3) as
    the repository source, for easier debugging
  - skipped new namespacing tests that fail with older Moose versions,
    due to an inability to install blessed subs
  - declared (not imported) types are now properly installed into the
    proper package, so they survive namespace::autoclean (fixed this
    time)
* Sun Feb  9 2014 coolo@suse.com
- updated to 0.41
  - reversed changes in 0.40, until compatibility issues with older
    Moose versions are figured out
  - types are now properly installed into the proper package, so they
    survive namespace::autoclean
* Mon Dec  9 2013 coolo@suse.com
- updated to 0.39
  - more strict warnings checking in tests
  - re-release to fix compile test
* Fri Oct  4 2013 coolo@suse.com
- updated to 0.38
  - removed use of deprecated enum syntax
  - removed use of deprecated Class::MOP::load_class
  - repository has moved to the GitHub Moose organization
* Wed Jul 24 2013 coolo@suse.com
- updated to 0.36
  - fixed failing tests on 5.8.5 due to incorrect == overload
    (RT#77100, Graham Knop)
* Wed May 30 2012 coolo@suse.com
- updated to 0.35
  - The new delegation code could fail when a type had no
    parent. Attempting to subtype Any was one way to trigger the
    bug. (Dave Rolsky)
  - The new delegation code broke calling ->can or ->isa on
    MooseX::Types::TypeDecorator as a class method. (Dave Rolsky)
  - Special case new to avoid unexpected exceptions on unloaded classes
  - Switch delegation order to prioritise type over class except for new
  - Support delegation of methods to the class for class types
  - Factor out _try_delegate method
* Tue Feb 14 2012 coolo@suse.com
- updated to 0.31
  - Add support for qw( :all ) on MooseX::Types::Combine libraries.
* Tue Dec  6 2011 coolo@suse.com
- shorten license string
* Fri Nov 18 2011 coolo@suse.com
- update to 0.30:
  - Fix a bug in the tests that caused failures with Moose HEAD. (doy)
  - Require namespace::clean 0.19. Tests fail with 0.18. Reported by
    Ruslan Zakirov. RT #67923.
  - Fixed git and bug tracking info in META.{yml,json}. Reported by
    Petter Rabbitson. (Dave Rolsky)
* Wed Jun  8 2011 coolo@novell.com
- update to 0.27:
  - A better fix for type constraint changes in Moose 2.0100. (doy)
* Sun Jun  5 2011 pascal.bleser@opensuse.org
- update to 0.26:
  * small changes for forward compatibility with Moose 2.0100, when it is
    released
  * some small doc cleanup and improvements
- changes from 0.25:
  * the test suite now uses Test::Fatal instead of Test::Exception
  * modernized tests to use Test::Requires and done_testing
  * MooseX::Types::Combine is a little more efficient, and only tries to load
    the libraries it's combining when that list is set. It also checks that
    each lib in the list actually provides types
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Mon Nov 29 2010 coolo@novell.com
- remove /var/adm/perl-modules
* Thu Nov  4 2010 pascal.bleser@opensuse.org
- update to 0.24 (no user-visible changes)
- changes from 0.22:
  * ypdate docs to mention MRO::Compat rather than Class::C3
  * added '0+' overloading to solve the type constraint equality regression introduced when Moose 1.05 tightened the rules determing type constraint equality
- changes from 0.21:
  * attempting to import a non-existent type from a combined type library gave a very confusing error message from the MooseX::Types::Combined internals. Now it gives you a much more useful message
  * bump up Moose dep (RT#53016)
* Tue Jan 12 2010 nine@detonation.org
- Specfile autogenerated by cpanspec 1.78.
